# coding=utf-8
# *** WARNING: this file was generated by test. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'AvailabilityInformationResponse',
    'BillingMeterDetailsResponse',
    'ConfigurationResponse',
    'CostInformationResponse',
    'DescriptionResponse',
    'DimensionsResponse',
    'FilterablePropertyResponse',
    'HierarchyInformationResponse',
    'ImageInformationResponse',
    'LinkResponse',
    'Pav2MeterDetailsResponse',
    'ProductFamilyResponse',
    'ProductLineResponse',
    'ProductResponse',
    'PurchaseMeterDetailsResponse',
    'SpecificationResponse',
]

@pulumi.output_type
class AvailabilityInformationResponse(dict):
    """
    Availability information of a product system.
    """
    def __init__(__self__, *,
                 availability_stage: str,
                 disabled_reason: str,
                 disabled_reason_message: str):
        """
        Availability information of a product system.
        :param str availability_stage: Current availability stage of the product. Availability stage
        :param str disabled_reason: Reason why the product is disabled.
        :param str disabled_reason_message: Message for why the product is disabled.
        """
        AvailabilityInformationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_stage=availability_stage,
            disabled_reason=disabled_reason,
            disabled_reason_message=disabled_reason_message,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_stage: Optional[str] = None,
             disabled_reason: Optional[str] = None,
             disabled_reason_message: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_stage is None and 'availabilityStage' in kwargs:
            availability_stage = kwargs['availabilityStage']
        if availability_stage is None:
            raise TypeError("Missing 'availability_stage' argument")
        if disabled_reason is None and 'disabledReason' in kwargs:
            disabled_reason = kwargs['disabledReason']
        if disabled_reason is None:
            raise TypeError("Missing 'disabled_reason' argument")
        if disabled_reason_message is None and 'disabledReasonMessage' in kwargs:
            disabled_reason_message = kwargs['disabledReasonMessage']
        if disabled_reason_message is None:
            raise TypeError("Missing 'disabled_reason_message' argument")

        _setter("availability_stage", availability_stage)
        _setter("disabled_reason", disabled_reason)
        _setter("disabled_reason_message", disabled_reason_message)

    @property
    @pulumi.getter(name="availabilityStage")
    def availability_stage(self) -> str:
        """
        Current availability stage of the product. Availability stage
        """
        return pulumi.get(self, "availability_stage")

    @property
    @pulumi.getter(name="disabledReason")
    def disabled_reason(self) -> str:
        """
        Reason why the product is disabled.
        """
        return pulumi.get(self, "disabled_reason")

    @property
    @pulumi.getter(name="disabledReasonMessage")
    def disabled_reason_message(self) -> str:
        """
        Message for why the product is disabled.
        """
        return pulumi.get(self, "disabled_reason_message")


@pulumi.output_type
class BillingMeterDetailsResponse(dict):
    """
    Holds billing meter details for each type of billing
    """
    def __init__(__self__, *,
                 frequency: str,
                 meter_details: Any,
                 metering_type: str,
                 name: str):
        """
        Holds billing meter details for each type of billing
        :param str frequency: Frequency of recurrence
        :param Union['Pav2MeterDetailsResponse', 'PurchaseMeterDetailsResponse'] meter_details: Represents MeterDetails
        :param str metering_type: Represents Metering type (eg one-time or recurrent)
        :param str name: Represents Billing type name
        """
        BillingMeterDetailsResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            frequency=frequency,
            meter_details=meter_details,
            metering_type=metering_type,
            name=name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             frequency: Optional[str] = None,
             meter_details: Optional[Any] = None,
             metering_type: Optional[str] = None,
             name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if frequency is None:
            raise TypeError("Missing 'frequency' argument")
        if meter_details is None and 'meterDetails' in kwargs:
            meter_details = kwargs['meterDetails']
        if meter_details is None:
            raise TypeError("Missing 'meter_details' argument")
        if metering_type is None and 'meteringType' in kwargs:
            metering_type = kwargs['meteringType']
        if metering_type is None:
            raise TypeError("Missing 'metering_type' argument")
        if name is None:
            raise TypeError("Missing 'name' argument")

        _setter("frequency", frequency)
        _setter("meter_details", meter_details)
        _setter("metering_type", metering_type)
        _setter("name", name)

    @property
    @pulumi.getter
    def frequency(self) -> str:
        """
        Frequency of recurrence
        """
        return pulumi.get(self, "frequency")

    @property
    @pulumi.getter(name="meterDetails")
    def meter_details(self) -> Any:
        """
        Represents MeterDetails
        """
        return pulumi.get(self, "meter_details")

    @property
    @pulumi.getter(name="meteringType")
    def metering_type(self) -> str:
        """
        Represents Metering type (eg one-time or recurrent)
        """
        return pulumi.get(self, "metering_type")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Represents Billing type name
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class ConfigurationResponse(dict):
    """
    Configuration object.
    """
    def __init__(__self__, *,
                 availability_information: 'outputs.AvailabilityInformationResponse',
                 cost_information: 'outputs.CostInformationResponse',
                 description: 'outputs.DescriptionResponse',
                 dimensions: 'outputs.DimensionsResponse',
                 display_name: str,
                 filterable_properties: Sequence['outputs.FilterablePropertyResponse'],
                 hierarchy_information: 'outputs.HierarchyInformationResponse',
                 image_information: Sequence['outputs.ImageInformationResponse'],
                 specifications: Sequence['outputs.SpecificationResponse']):
        """
        Configuration object.
        :param 'AvailabilityInformationResponse' availability_information: Availability information of the product system.
        :param 'CostInformationResponse' cost_information: Cost information for the product system.
        :param 'DescriptionResponse' description: Description related to the product system.
        :param 'DimensionsResponse' dimensions: Dimensions of the configuration
        :param str display_name: Display Name for the product system.
        :param Sequence['FilterablePropertyResponse'] filterable_properties: list of filters supported for a product
        :param 'HierarchyInformationResponse' hierarchy_information: Hierarchy information of a product.
        :param Sequence['ImageInformationResponse'] image_information: Image information for the product system.
        :param Sequence['SpecificationResponse'] specifications: Specifications of the configuration
        """
        ConfigurationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_information=availability_information,
            cost_information=cost_information,
            description=description,
            dimensions=dimensions,
            display_name=display_name,
            filterable_properties=filterable_properties,
            hierarchy_information=hierarchy_information,
            image_information=image_information,
            specifications=specifications,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_information: Optional['outputs.AvailabilityInformationResponse'] = None,
             cost_information: Optional['outputs.CostInformationResponse'] = None,
             description: Optional['outputs.DescriptionResponse'] = None,
             dimensions: Optional['outputs.DimensionsResponse'] = None,
             display_name: Optional[str] = None,
             filterable_properties: Optional[Sequence['outputs.FilterablePropertyResponse']] = None,
             hierarchy_information: Optional['outputs.HierarchyInformationResponse'] = None,
             image_information: Optional[Sequence['outputs.ImageInformationResponse']] = None,
             specifications: Optional[Sequence['outputs.SpecificationResponse']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_information is None and 'availabilityInformation' in kwargs:
            availability_information = kwargs['availabilityInformation']
        if availability_information is None:
            raise TypeError("Missing 'availability_information' argument")
        if cost_information is None and 'costInformation' in kwargs:
            cost_information = kwargs['costInformation']
        if cost_information is None:
            raise TypeError("Missing 'cost_information' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if dimensions is None:
            raise TypeError("Missing 'dimensions' argument")
        if display_name is None and 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if display_name is None:
            raise TypeError("Missing 'display_name' argument")
        if filterable_properties is None and 'filterableProperties' in kwargs:
            filterable_properties = kwargs['filterableProperties']
        if filterable_properties is None:
            raise TypeError("Missing 'filterable_properties' argument")
        if hierarchy_information is None and 'hierarchyInformation' in kwargs:
            hierarchy_information = kwargs['hierarchyInformation']
        if hierarchy_information is None:
            raise TypeError("Missing 'hierarchy_information' argument")
        if image_information is None and 'imageInformation' in kwargs:
            image_information = kwargs['imageInformation']
        if image_information is None:
            raise TypeError("Missing 'image_information' argument")
        if specifications is None:
            raise TypeError("Missing 'specifications' argument")

        _setter("availability_information", availability_information)
        _setter("cost_information", cost_information)
        _setter("description", description)
        _setter("dimensions", dimensions)
        _setter("display_name", display_name)
        _setter("filterable_properties", filterable_properties)
        _setter("hierarchy_information", hierarchy_information)
        _setter("image_information", image_information)
        _setter("specifications", specifications)

    @property
    @pulumi.getter(name="availabilityInformation")
    def availability_information(self) -> 'outputs.AvailabilityInformationResponse':
        """
        Availability information of the product system.
        """
        return pulumi.get(self, "availability_information")

    @property
    @pulumi.getter(name="costInformation")
    def cost_information(self) -> 'outputs.CostInformationResponse':
        """
        Cost information for the product system.
        """
        return pulumi.get(self, "cost_information")

    @property
    @pulumi.getter
    def description(self) -> 'outputs.DescriptionResponse':
        """
        Description related to the product system.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def dimensions(self) -> 'outputs.DimensionsResponse':
        """
        Dimensions of the configuration
        """
        return pulumi.get(self, "dimensions")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        Display Name for the product system.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="filterableProperties")
    def filterable_properties(self) -> Sequence['outputs.FilterablePropertyResponse']:
        """
        list of filters supported for a product
        """
        return pulumi.get(self, "filterable_properties")

    @property
    @pulumi.getter(name="hierarchyInformation")
    def hierarchy_information(self) -> 'outputs.HierarchyInformationResponse':
        """
        Hierarchy information of a product.
        """
        return pulumi.get(self, "hierarchy_information")

    @property
    @pulumi.getter(name="imageInformation")
    def image_information(self) -> Sequence['outputs.ImageInformationResponse']:
        """
        Image information for the product system.
        """
        return pulumi.get(self, "image_information")

    @property
    @pulumi.getter
    def specifications(self) -> Sequence['outputs.SpecificationResponse']:
        """
        Specifications of the configuration
        """
        return pulumi.get(self, "specifications")


@pulumi.output_type
class CostInformationResponse(dict):
    """
    Cost information for the product system
    """
    def __init__(__self__, *,
                 billing_info_url: str,
                 billing_meter_details: Sequence['outputs.BillingMeterDetailsResponse']):
        """
        Cost information for the product system
        :param str billing_info_url: Default url to display billing information
        :param Sequence['BillingMeterDetailsResponse'] billing_meter_details: Details on the various billing aspects for the product system.
        """
        CostInformationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            billing_info_url=billing_info_url,
            billing_meter_details=billing_meter_details,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             billing_info_url: Optional[str] = None,
             billing_meter_details: Optional[Sequence['outputs.BillingMeterDetailsResponse']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if billing_info_url is None and 'billingInfoUrl' in kwargs:
            billing_info_url = kwargs['billingInfoUrl']
        if billing_info_url is None:
            raise TypeError("Missing 'billing_info_url' argument")
        if billing_meter_details is None and 'billingMeterDetails' in kwargs:
            billing_meter_details = kwargs['billingMeterDetails']
        if billing_meter_details is None:
            raise TypeError("Missing 'billing_meter_details' argument")

        _setter("billing_info_url", billing_info_url)
        _setter("billing_meter_details", billing_meter_details)

    @property
    @pulumi.getter(name="billingInfoUrl")
    def billing_info_url(self) -> str:
        """
        Default url to display billing information
        """
        return pulumi.get(self, "billing_info_url")

    @property
    @pulumi.getter(name="billingMeterDetails")
    def billing_meter_details(self) -> Sequence['outputs.BillingMeterDetailsResponse']:
        """
        Details on the various billing aspects for the product system.
        """
        return pulumi.get(self, "billing_meter_details")


@pulumi.output_type
class DescriptionResponse(dict):
    """
    Description related properties of a product system.
    """
    def __init__(__self__, *,
                 attributes: Sequence[str],
                 description_type: str,
                 keywords: Sequence[str],
                 links: Sequence['outputs.LinkResponse'],
                 long_description: str,
                 short_description: str):
        """
        Description related properties of a product system.
        :param Sequence[str] attributes: Attributes for the product system.
        :param str description_type: Type of description.
        :param Sequence[str] keywords: Keywords for the product system.
        :param Sequence['LinkResponse'] links: Links for the product system.
        :param str long_description: Long description of the product system.
        :param str short_description: Short description of the product system.
        """
        DescriptionResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            attributes=attributes,
            description_type=description_type,
            keywords=keywords,
            links=links,
            long_description=long_description,
            short_description=short_description,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             attributes: Optional[Sequence[str]] = None,
             description_type: Optional[str] = None,
             keywords: Optional[Sequence[str]] = None,
             links: Optional[Sequence['outputs.LinkResponse']] = None,
             long_description: Optional[str] = None,
             short_description: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if attributes is None:
            raise TypeError("Missing 'attributes' argument")
        if description_type is None and 'descriptionType' in kwargs:
            description_type = kwargs['descriptionType']
        if description_type is None:
            raise TypeError("Missing 'description_type' argument")
        if keywords is None:
            raise TypeError("Missing 'keywords' argument")
        if links is None:
            raise TypeError("Missing 'links' argument")
        if long_description is None and 'longDescription' in kwargs:
            long_description = kwargs['longDescription']
        if long_description is None:
            raise TypeError("Missing 'long_description' argument")
        if short_description is None and 'shortDescription' in kwargs:
            short_description = kwargs['shortDescription']
        if short_description is None:
            raise TypeError("Missing 'short_description' argument")

        _setter("attributes", attributes)
        _setter("description_type", description_type)
        _setter("keywords", keywords)
        _setter("links", links)
        _setter("long_description", long_description)
        _setter("short_description", short_description)

    @property
    @pulumi.getter
    def attributes(self) -> Sequence[str]:
        """
        Attributes for the product system.
        """
        return pulumi.get(self, "attributes")

    @property
    @pulumi.getter(name="descriptionType")
    def description_type(self) -> str:
        """
        Type of description.
        """
        return pulumi.get(self, "description_type")

    @property
    @pulumi.getter
    def keywords(self) -> Sequence[str]:
        """
        Keywords for the product system.
        """
        return pulumi.get(self, "keywords")

    @property
    @pulumi.getter
    def links(self) -> Sequence['outputs.LinkResponse']:
        """
        Links for the product system.
        """
        return pulumi.get(self, "links")

    @property
    @pulumi.getter(name="longDescription")
    def long_description(self) -> str:
        """
        Long description of the product system.
        """
        return pulumi.get(self, "long_description")

    @property
    @pulumi.getter(name="shortDescription")
    def short_description(self) -> str:
        """
        Short description of the product system.
        """
        return pulumi.get(self, "short_description")


@pulumi.output_type
class DimensionsResponse(dict):
    """
    Dimensions of a configuration.
    """
    def __init__(__self__, *,
                 depth: float,
                 height: float,
                 length: float,
                 length_height_unit: str,
                 weight: float,
                 weight_unit: str,
                 width: float):
        """
        Dimensions of a configuration.
        :param float depth: Depth of the device.
        :param float height: Height of the device.
        :param float length: Length of the device.
        :param str length_height_unit: Unit for the dimensions of length, height and width.
        :param float weight: Weight of the device.
        :param str weight_unit: Unit for the dimensions of weight.
        :param float width: Width of the device.
        """
        DimensionsResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            depth=depth,
            height=height,
            length=length,
            length_height_unit=length_height_unit,
            weight=weight,
            weight_unit=weight_unit,
            width=width,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             depth: Optional[float] = None,
             height: Optional[float] = None,
             length: Optional[float] = None,
             length_height_unit: Optional[str] = None,
             weight: Optional[float] = None,
             weight_unit: Optional[str] = None,
             width: Optional[float] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if depth is None:
            raise TypeError("Missing 'depth' argument")
        if height is None:
            raise TypeError("Missing 'height' argument")
        if length is None:
            raise TypeError("Missing 'length' argument")
        if length_height_unit is None and 'lengthHeightUnit' in kwargs:
            length_height_unit = kwargs['lengthHeightUnit']
        if length_height_unit is None:
            raise TypeError("Missing 'length_height_unit' argument")
        if weight is None:
            raise TypeError("Missing 'weight' argument")
        if weight_unit is None and 'weightUnit' in kwargs:
            weight_unit = kwargs['weightUnit']
        if weight_unit is None:
            raise TypeError("Missing 'weight_unit' argument")
        if width is None:
            raise TypeError("Missing 'width' argument")

        _setter("depth", depth)
        _setter("height", height)
        _setter("length", length)
        _setter("length_height_unit", length_height_unit)
        _setter("weight", weight)
        _setter("weight_unit", weight_unit)
        _setter("width", width)

    @property
    @pulumi.getter
    def depth(self) -> float:
        """
        Depth of the device.
        """
        return pulumi.get(self, "depth")

    @property
    @pulumi.getter
    def height(self) -> float:
        """
        Height of the device.
        """
        return pulumi.get(self, "height")

    @property
    @pulumi.getter
    def length(self) -> float:
        """
        Length of the device.
        """
        return pulumi.get(self, "length")

    @property
    @pulumi.getter(name="lengthHeightUnit")
    def length_height_unit(self) -> str:
        """
        Unit for the dimensions of length, height and width.
        """
        return pulumi.get(self, "length_height_unit")

    @property
    @pulumi.getter
    def weight(self) -> float:
        """
        Weight of the device.
        """
        return pulumi.get(self, "weight")

    @property
    @pulumi.getter(name="weightUnit")
    def weight_unit(self) -> str:
        """
        Unit for the dimensions of weight.
        """
        return pulumi.get(self, "weight_unit")

    @property
    @pulumi.getter
    def width(self) -> float:
        """
        Width of the device.
        """
        return pulumi.get(self, "width")


@pulumi.output_type
class FilterablePropertyResponse(dict):
    """
    Different types of filters supported and its values.
    """
    def __init__(__self__, *,
                 supported_values: Sequence[str],
                 type: str):
        """
        Different types of filters supported and its values.
        :param Sequence[str] supported_values: Values to be filtered.
        :param str type: Type of product filter.
        """
        FilterablePropertyResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            supported_values=supported_values,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             supported_values: Optional[Sequence[str]] = None,
             type: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if supported_values is None and 'supportedValues' in kwargs:
            supported_values = kwargs['supportedValues']
        if supported_values is None:
            raise TypeError("Missing 'supported_values' argument")
        if type is None:
            raise TypeError("Missing 'type' argument")

        _setter("supported_values", supported_values)
        _setter("type", type)

    @property
    @pulumi.getter(name="supportedValues")
    def supported_values(self) -> Sequence[str]:
        """
        Values to be filtered.
        """
        return pulumi.get(self, "supported_values")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Type of product filter.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class HierarchyInformationResponse(dict):
    """
    Holds details about product hierarchy information
    """
    def __init__(__self__, *,
                 configuration_name: Optional[str] = None,
                 product_family_name: Optional[str] = None,
                 product_line_name: Optional[str] = None,
                 product_name: Optional[str] = None):
        """
        Holds details about product hierarchy information
        :param str configuration_name: Represents configuration name that uniquely identifies configuration
        :param str product_family_name: Represents product family name that uniquely identifies product family
        :param str product_line_name: Represents product line name that uniquely identifies product line
        :param str product_name: Represents product name that uniquely identifies product
        """
        HierarchyInformationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            configuration_name=configuration_name,
            product_family_name=product_family_name,
            product_line_name=product_line_name,
            product_name=product_name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             configuration_name: Optional[str] = None,
             product_family_name: Optional[str] = None,
             product_line_name: Optional[str] = None,
             product_name: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if configuration_name is None and 'configurationName' in kwargs:
            configuration_name = kwargs['configurationName']
        if product_family_name is None and 'productFamilyName' in kwargs:
            product_family_name = kwargs['productFamilyName']
        if product_line_name is None and 'productLineName' in kwargs:
            product_line_name = kwargs['productLineName']
        if product_name is None and 'productName' in kwargs:
            product_name = kwargs['productName']

        if configuration_name is not None:
            _setter("configuration_name", configuration_name)
        if product_family_name is not None:
            _setter("product_family_name", product_family_name)
        if product_line_name is not None:
            _setter("product_line_name", product_line_name)
        if product_name is not None:
            _setter("product_name", product_name)

    @property
    @pulumi.getter(name="configurationName")
    def configuration_name(self) -> Optional[str]:
        """
        Represents configuration name that uniquely identifies configuration
        """
        return pulumi.get(self, "configuration_name")

    @property
    @pulumi.getter(name="productFamilyName")
    def product_family_name(self) -> Optional[str]:
        """
        Represents product family name that uniquely identifies product family
        """
        return pulumi.get(self, "product_family_name")

    @property
    @pulumi.getter(name="productLineName")
    def product_line_name(self) -> Optional[str]:
        """
        Represents product line name that uniquely identifies product line
        """
        return pulumi.get(self, "product_line_name")

    @property
    @pulumi.getter(name="productName")
    def product_name(self) -> Optional[str]:
        """
        Represents product name that uniquely identifies product
        """
        return pulumi.get(self, "product_name")


@pulumi.output_type
class ImageInformationResponse(dict):
    """
    Image for the product
    """
    def __init__(__self__, *,
                 image_type: str,
                 image_url: str):
        """
        Image for the product
        :param str image_type: Type of the image
        :param str image_url: Url of the image
        """
        ImageInformationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            image_type=image_type,
            image_url=image_url,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             image_type: Optional[str] = None,
             image_url: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if image_type is None and 'imageType' in kwargs:
            image_type = kwargs['imageType']
        if image_type is None:
            raise TypeError("Missing 'image_type' argument")
        if image_url is None and 'imageUrl' in kwargs:
            image_url = kwargs['imageUrl']
        if image_url is None:
            raise TypeError("Missing 'image_url' argument")

        _setter("image_type", image_type)
        _setter("image_url", image_url)

    @property
    @pulumi.getter(name="imageType")
    def image_type(self) -> str:
        """
        Type of the image
        """
        return pulumi.get(self, "image_type")

    @property
    @pulumi.getter(name="imageUrl")
    def image_url(self) -> str:
        """
        Url of the image
        """
        return pulumi.get(self, "image_url")


@pulumi.output_type
class LinkResponse(dict):
    """
    Returns link related to the product
    """
    def __init__(__self__, *,
                 link_type: str,
                 link_url: str):
        """
        Returns link related to the product
        :param str link_type: Type of link
        :param str link_url: Url of the link
        """
        LinkResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            link_type=link_type,
            link_url=link_url,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             link_type: Optional[str] = None,
             link_url: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if link_type is None and 'linkType' in kwargs:
            link_type = kwargs['linkType']
        if link_type is None:
            raise TypeError("Missing 'link_type' argument")
        if link_url is None and 'linkUrl' in kwargs:
            link_url = kwargs['linkUrl']
        if link_url is None:
            raise TypeError("Missing 'link_url' argument")

        _setter("link_type", link_type)
        _setter("link_url", link_url)

    @property
    @pulumi.getter(name="linkType")
    def link_type(self) -> str:
        """
        Type of link
        """
        return pulumi.get(self, "link_type")

    @property
    @pulumi.getter(name="linkUrl")
    def link_url(self) -> str:
        """
        Url of the link
        """
        return pulumi.get(self, "link_url")


@pulumi.output_type
class Pav2MeterDetailsResponse(dict):
    """
    Billing type PAV2 meter details
    """
    def __init__(__self__, *,
                 billing_type: str,
                 charging_type: str,
                 meter_guid: str,
                 multiplier: float):
        """
        Billing type PAV2 meter details
        :param str billing_type: Represents billing type.
               Expected value is 'Pav2'.
        :param str charging_type: Charging type.
        :param str meter_guid: Validation status of requested data center and transport.
        :param float multiplier: Billing unit applicable for Pav2 billing
        """
        Pav2MeterDetailsResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            billing_type=billing_type,
            charging_type=charging_type,
            meter_guid=meter_guid,
            multiplier=multiplier,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             billing_type: Optional[str] = None,
             charging_type: Optional[str] = None,
             meter_guid: Optional[str] = None,
             multiplier: Optional[float] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if billing_type is None and 'billingType' in kwargs:
            billing_type = kwargs['billingType']
        if billing_type is None:
            raise TypeError("Missing 'billing_type' argument")
        if charging_type is None and 'chargingType' in kwargs:
            charging_type = kwargs['chargingType']
        if charging_type is None:
            raise TypeError("Missing 'charging_type' argument")
        if meter_guid is None and 'meterGuid' in kwargs:
            meter_guid = kwargs['meterGuid']
        if meter_guid is None:
            raise TypeError("Missing 'meter_guid' argument")
        if multiplier is None:
            raise TypeError("Missing 'multiplier' argument")

        _setter("billing_type", 'Pav2')
        _setter("charging_type", charging_type)
        _setter("meter_guid", meter_guid)
        _setter("multiplier", multiplier)

    @property
    @pulumi.getter(name="billingType")
    def billing_type(self) -> str:
        """
        Represents billing type.
        Expected value is 'Pav2'.
        """
        return pulumi.get(self, "billing_type")

    @property
    @pulumi.getter(name="chargingType")
    def charging_type(self) -> str:
        """
        Charging type.
        """
        return pulumi.get(self, "charging_type")

    @property
    @pulumi.getter(name="meterGuid")
    def meter_guid(self) -> str:
        """
        Validation status of requested data center and transport.
        """
        return pulumi.get(self, "meter_guid")

    @property
    @pulumi.getter
    def multiplier(self) -> float:
        """
        Billing unit applicable for Pav2 billing
        """
        return pulumi.get(self, "multiplier")


@pulumi.output_type
class ProductFamilyResponse(dict):
    """
    Product Family
    """
    def __init__(__self__, *,
                 availability_information: 'outputs.AvailabilityInformationResponse',
                 cost_information: 'outputs.CostInformationResponse',
                 description: 'outputs.DescriptionResponse',
                 display_name: str,
                 filterable_properties: Sequence['outputs.FilterablePropertyResponse'],
                 hierarchy_information: 'outputs.HierarchyInformationResponse',
                 image_information: Sequence['outputs.ImageInformationResponse'],
                 product_lines: Sequence['outputs.ProductLineResponse']):
        """
        Product Family
        :param 'AvailabilityInformationResponse' availability_information: Availability information of the product system.
        :param 'CostInformationResponse' cost_information: Cost information for the product system.
        :param 'DescriptionResponse' description: Description related to the product system.
        :param str display_name: Display Name for the product system.
        :param Sequence['FilterablePropertyResponse'] filterable_properties: list of filters supported for a product
        :param 'HierarchyInformationResponse' hierarchy_information: Hierarchy information of a product.
        :param Sequence['ImageInformationResponse'] image_information: Image information for the product system.
        :param Sequence['ProductLineResponse'] product_lines: List of product lines supported in the product family
        """
        ProductFamilyResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_information=availability_information,
            cost_information=cost_information,
            description=description,
            display_name=display_name,
            filterable_properties=filterable_properties,
            hierarchy_information=hierarchy_information,
            image_information=image_information,
            product_lines=product_lines,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_information: Optional['outputs.AvailabilityInformationResponse'] = None,
             cost_information: Optional['outputs.CostInformationResponse'] = None,
             description: Optional['outputs.DescriptionResponse'] = None,
             display_name: Optional[str] = None,
             filterable_properties: Optional[Sequence['outputs.FilterablePropertyResponse']] = None,
             hierarchy_information: Optional['outputs.HierarchyInformationResponse'] = None,
             image_information: Optional[Sequence['outputs.ImageInformationResponse']] = None,
             product_lines: Optional[Sequence['outputs.ProductLineResponse']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_information is None and 'availabilityInformation' in kwargs:
            availability_information = kwargs['availabilityInformation']
        if availability_information is None:
            raise TypeError("Missing 'availability_information' argument")
        if cost_information is None and 'costInformation' in kwargs:
            cost_information = kwargs['costInformation']
        if cost_information is None:
            raise TypeError("Missing 'cost_information' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if display_name is None and 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if display_name is None:
            raise TypeError("Missing 'display_name' argument")
        if filterable_properties is None and 'filterableProperties' in kwargs:
            filterable_properties = kwargs['filterableProperties']
        if filterable_properties is None:
            raise TypeError("Missing 'filterable_properties' argument")
        if hierarchy_information is None and 'hierarchyInformation' in kwargs:
            hierarchy_information = kwargs['hierarchyInformation']
        if hierarchy_information is None:
            raise TypeError("Missing 'hierarchy_information' argument")
        if image_information is None and 'imageInformation' in kwargs:
            image_information = kwargs['imageInformation']
        if image_information is None:
            raise TypeError("Missing 'image_information' argument")
        if product_lines is None and 'productLines' in kwargs:
            product_lines = kwargs['productLines']
        if product_lines is None:
            raise TypeError("Missing 'product_lines' argument")

        _setter("availability_information", availability_information)
        _setter("cost_information", cost_information)
        _setter("description", description)
        _setter("display_name", display_name)
        _setter("filterable_properties", filterable_properties)
        _setter("hierarchy_information", hierarchy_information)
        _setter("image_information", image_information)
        _setter("product_lines", product_lines)

    @property
    @pulumi.getter(name="availabilityInformation")
    def availability_information(self) -> 'outputs.AvailabilityInformationResponse':
        """
        Availability information of the product system.
        """
        return pulumi.get(self, "availability_information")

    @property
    @pulumi.getter(name="costInformation")
    def cost_information(self) -> 'outputs.CostInformationResponse':
        """
        Cost information for the product system.
        """
        return pulumi.get(self, "cost_information")

    @property
    @pulumi.getter
    def description(self) -> 'outputs.DescriptionResponse':
        """
        Description related to the product system.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        Display Name for the product system.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="filterableProperties")
    def filterable_properties(self) -> Sequence['outputs.FilterablePropertyResponse']:
        """
        list of filters supported for a product
        """
        return pulumi.get(self, "filterable_properties")

    @property
    @pulumi.getter(name="hierarchyInformation")
    def hierarchy_information(self) -> 'outputs.HierarchyInformationResponse':
        """
        Hierarchy information of a product.
        """
        return pulumi.get(self, "hierarchy_information")

    @property
    @pulumi.getter(name="imageInformation")
    def image_information(self) -> Sequence['outputs.ImageInformationResponse']:
        """
        Image information for the product system.
        """
        return pulumi.get(self, "image_information")

    @property
    @pulumi.getter(name="productLines")
    def product_lines(self) -> Sequence['outputs.ProductLineResponse']:
        """
        List of product lines supported in the product family
        """
        return pulumi.get(self, "product_lines")


@pulumi.output_type
class ProductLineResponse(dict):
    """
    Product line
    """
    def __init__(__self__, *,
                 availability_information: 'outputs.AvailabilityInformationResponse',
                 cost_information: 'outputs.CostInformationResponse',
                 description: 'outputs.DescriptionResponse',
                 display_name: str,
                 filterable_properties: Sequence['outputs.FilterablePropertyResponse'],
                 hierarchy_information: 'outputs.HierarchyInformationResponse',
                 image_information: Sequence['outputs.ImageInformationResponse'],
                 products: Sequence['outputs.ProductResponse']):
        """
        Product line
        :param 'AvailabilityInformationResponse' availability_information: Availability information of the product system.
        :param 'CostInformationResponse' cost_information: Cost information for the product system.
        :param 'DescriptionResponse' description: Description related to the product system.
        :param str display_name: Display Name for the product system.
        :param Sequence['FilterablePropertyResponse'] filterable_properties: list of filters supported for a product
        :param 'HierarchyInformationResponse' hierarchy_information: Hierarchy information of a product.
        :param Sequence['ImageInformationResponse'] image_information: Image information for the product system.
        :param Sequence['ProductResponse'] products: List of products in the product line
        """
        ProductLineResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_information=availability_information,
            cost_information=cost_information,
            description=description,
            display_name=display_name,
            filterable_properties=filterable_properties,
            hierarchy_information=hierarchy_information,
            image_information=image_information,
            products=products,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_information: Optional['outputs.AvailabilityInformationResponse'] = None,
             cost_information: Optional['outputs.CostInformationResponse'] = None,
             description: Optional['outputs.DescriptionResponse'] = None,
             display_name: Optional[str] = None,
             filterable_properties: Optional[Sequence['outputs.FilterablePropertyResponse']] = None,
             hierarchy_information: Optional['outputs.HierarchyInformationResponse'] = None,
             image_information: Optional[Sequence['outputs.ImageInformationResponse']] = None,
             products: Optional[Sequence['outputs.ProductResponse']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_information is None and 'availabilityInformation' in kwargs:
            availability_information = kwargs['availabilityInformation']
        if availability_information is None:
            raise TypeError("Missing 'availability_information' argument")
        if cost_information is None and 'costInformation' in kwargs:
            cost_information = kwargs['costInformation']
        if cost_information is None:
            raise TypeError("Missing 'cost_information' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if display_name is None and 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if display_name is None:
            raise TypeError("Missing 'display_name' argument")
        if filterable_properties is None and 'filterableProperties' in kwargs:
            filterable_properties = kwargs['filterableProperties']
        if filterable_properties is None:
            raise TypeError("Missing 'filterable_properties' argument")
        if hierarchy_information is None and 'hierarchyInformation' in kwargs:
            hierarchy_information = kwargs['hierarchyInformation']
        if hierarchy_information is None:
            raise TypeError("Missing 'hierarchy_information' argument")
        if image_information is None and 'imageInformation' in kwargs:
            image_information = kwargs['imageInformation']
        if image_information is None:
            raise TypeError("Missing 'image_information' argument")
        if products is None:
            raise TypeError("Missing 'products' argument")

        _setter("availability_information", availability_information)
        _setter("cost_information", cost_information)
        _setter("description", description)
        _setter("display_name", display_name)
        _setter("filterable_properties", filterable_properties)
        _setter("hierarchy_information", hierarchy_information)
        _setter("image_information", image_information)
        _setter("products", products)

    @property
    @pulumi.getter(name="availabilityInformation")
    def availability_information(self) -> 'outputs.AvailabilityInformationResponse':
        """
        Availability information of the product system.
        """
        return pulumi.get(self, "availability_information")

    @property
    @pulumi.getter(name="costInformation")
    def cost_information(self) -> 'outputs.CostInformationResponse':
        """
        Cost information for the product system.
        """
        return pulumi.get(self, "cost_information")

    @property
    @pulumi.getter
    def description(self) -> 'outputs.DescriptionResponse':
        """
        Description related to the product system.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        Display Name for the product system.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="filterableProperties")
    def filterable_properties(self) -> Sequence['outputs.FilterablePropertyResponse']:
        """
        list of filters supported for a product
        """
        return pulumi.get(self, "filterable_properties")

    @property
    @pulumi.getter(name="hierarchyInformation")
    def hierarchy_information(self) -> 'outputs.HierarchyInformationResponse':
        """
        Hierarchy information of a product.
        """
        return pulumi.get(self, "hierarchy_information")

    @property
    @pulumi.getter(name="imageInformation")
    def image_information(self) -> Sequence['outputs.ImageInformationResponse']:
        """
        Image information for the product system.
        """
        return pulumi.get(self, "image_information")

    @property
    @pulumi.getter
    def products(self) -> Sequence['outputs.ProductResponse']:
        """
        List of products in the product line
        """
        return pulumi.get(self, "products")


@pulumi.output_type
class ProductResponse(dict):
    """
    List of Products
    """
    def __init__(__self__, *,
                 availability_information: 'outputs.AvailabilityInformationResponse',
                 configurations: Sequence['outputs.ConfigurationResponse'],
                 cost_information: 'outputs.CostInformationResponse',
                 description: 'outputs.DescriptionResponse',
                 display_name: str,
                 filterable_properties: Sequence['outputs.FilterablePropertyResponse'],
                 hierarchy_information: 'outputs.HierarchyInformationResponse',
                 image_information: Sequence['outputs.ImageInformationResponse']):
        """
        List of Products
        :param 'AvailabilityInformationResponse' availability_information: Availability information of the product system.
        :param Sequence['ConfigurationResponse'] configurations: List of configurations for the product
        :param 'CostInformationResponse' cost_information: Cost information for the product system.
        :param 'DescriptionResponse' description: Description related to the product system.
        :param str display_name: Display Name for the product system.
        :param Sequence['FilterablePropertyResponse'] filterable_properties: list of filters supported for a product
        :param 'HierarchyInformationResponse' hierarchy_information: Hierarchy information of a product.
        :param Sequence['ImageInformationResponse'] image_information: Image information for the product system.
        """
        ProductResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            availability_information=availability_information,
            configurations=configurations,
            cost_information=cost_information,
            description=description,
            display_name=display_name,
            filterable_properties=filterable_properties,
            hierarchy_information=hierarchy_information,
            image_information=image_information,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             availability_information: Optional['outputs.AvailabilityInformationResponse'] = None,
             configurations: Optional[Sequence['outputs.ConfigurationResponse']] = None,
             cost_information: Optional['outputs.CostInformationResponse'] = None,
             description: Optional['outputs.DescriptionResponse'] = None,
             display_name: Optional[str] = None,
             filterable_properties: Optional[Sequence['outputs.FilterablePropertyResponse']] = None,
             hierarchy_information: Optional['outputs.HierarchyInformationResponse'] = None,
             image_information: Optional[Sequence['outputs.ImageInformationResponse']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if availability_information is None and 'availabilityInformation' in kwargs:
            availability_information = kwargs['availabilityInformation']
        if availability_information is None:
            raise TypeError("Missing 'availability_information' argument")
        if configurations is None:
            raise TypeError("Missing 'configurations' argument")
        if cost_information is None and 'costInformation' in kwargs:
            cost_information = kwargs['costInformation']
        if cost_information is None:
            raise TypeError("Missing 'cost_information' argument")
        if description is None:
            raise TypeError("Missing 'description' argument")
        if display_name is None and 'displayName' in kwargs:
            display_name = kwargs['displayName']
        if display_name is None:
            raise TypeError("Missing 'display_name' argument")
        if filterable_properties is None and 'filterableProperties' in kwargs:
            filterable_properties = kwargs['filterableProperties']
        if filterable_properties is None:
            raise TypeError("Missing 'filterable_properties' argument")
        if hierarchy_information is None and 'hierarchyInformation' in kwargs:
            hierarchy_information = kwargs['hierarchyInformation']
        if hierarchy_information is None:
            raise TypeError("Missing 'hierarchy_information' argument")
        if image_information is None and 'imageInformation' in kwargs:
            image_information = kwargs['imageInformation']
        if image_information is None:
            raise TypeError("Missing 'image_information' argument")

        _setter("availability_information", availability_information)
        _setter("configurations", configurations)
        _setter("cost_information", cost_information)
        _setter("description", description)
        _setter("display_name", display_name)
        _setter("filterable_properties", filterable_properties)
        _setter("hierarchy_information", hierarchy_information)
        _setter("image_information", image_information)

    @property
    @pulumi.getter(name="availabilityInformation")
    def availability_information(self) -> 'outputs.AvailabilityInformationResponse':
        """
        Availability information of the product system.
        """
        return pulumi.get(self, "availability_information")

    @property
    @pulumi.getter
    def configurations(self) -> Sequence['outputs.ConfigurationResponse']:
        """
        List of configurations for the product
        """
        return pulumi.get(self, "configurations")

    @property
    @pulumi.getter(name="costInformation")
    def cost_information(self) -> 'outputs.CostInformationResponse':
        """
        Cost information for the product system.
        """
        return pulumi.get(self, "cost_information")

    @property
    @pulumi.getter
    def description(self) -> 'outputs.DescriptionResponse':
        """
        Description related to the product system.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> str:
        """
        Display Name for the product system.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="filterableProperties")
    def filterable_properties(self) -> Sequence['outputs.FilterablePropertyResponse']:
        """
        list of filters supported for a product
        """
        return pulumi.get(self, "filterable_properties")

    @property
    @pulumi.getter(name="hierarchyInformation")
    def hierarchy_information(self) -> 'outputs.HierarchyInformationResponse':
        """
        Hierarchy information of a product.
        """
        return pulumi.get(self, "hierarchy_information")

    @property
    @pulumi.getter(name="imageInformation")
    def image_information(self) -> Sequence['outputs.ImageInformationResponse']:
        """
        Image information for the product system.
        """
        return pulumi.get(self, "image_information")


@pulumi.output_type
class PurchaseMeterDetailsResponse(dict):
    """
    Billing type Purchase meter details
    """
    def __init__(__self__, *,
                 billing_type: str,
                 charging_type: str,
                 multiplier: float,
                 product_id: str,
                 sku_id: str,
                 term_id: str):
        """
        Billing type Purchase meter details
        :param str billing_type: Represents billing type.
               Expected value is 'Purchase'.
        :param str charging_type: Charging type.
        :param float multiplier: Billing unit applicable for Pav2 billing
        :param str product_id: Product Id
        :param str sku_id: Sku Id
        :param str term_id: Term Id
        """
        PurchaseMeterDetailsResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            billing_type=billing_type,
            charging_type=charging_type,
            multiplier=multiplier,
            product_id=product_id,
            sku_id=sku_id,
            term_id=term_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             billing_type: Optional[str] = None,
             charging_type: Optional[str] = None,
             multiplier: Optional[float] = None,
             product_id: Optional[str] = None,
             sku_id: Optional[str] = None,
             term_id: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if billing_type is None and 'billingType' in kwargs:
            billing_type = kwargs['billingType']
        if billing_type is None:
            raise TypeError("Missing 'billing_type' argument")
        if charging_type is None and 'chargingType' in kwargs:
            charging_type = kwargs['chargingType']
        if charging_type is None:
            raise TypeError("Missing 'charging_type' argument")
        if multiplier is None:
            raise TypeError("Missing 'multiplier' argument")
        if product_id is None and 'productId' in kwargs:
            product_id = kwargs['productId']
        if product_id is None:
            raise TypeError("Missing 'product_id' argument")
        if sku_id is None and 'skuId' in kwargs:
            sku_id = kwargs['skuId']
        if sku_id is None:
            raise TypeError("Missing 'sku_id' argument")
        if term_id is None and 'termId' in kwargs:
            term_id = kwargs['termId']
        if term_id is None:
            raise TypeError("Missing 'term_id' argument")

        _setter("billing_type", 'Purchase')
        _setter("charging_type", charging_type)
        _setter("multiplier", multiplier)
        _setter("product_id", product_id)
        _setter("sku_id", sku_id)
        _setter("term_id", term_id)

    @property
    @pulumi.getter(name="billingType")
    def billing_type(self) -> str:
        """
        Represents billing type.
        Expected value is 'Purchase'.
        """
        return pulumi.get(self, "billing_type")

    @property
    @pulumi.getter(name="chargingType")
    def charging_type(self) -> str:
        """
        Charging type.
        """
        return pulumi.get(self, "charging_type")

    @property
    @pulumi.getter
    def multiplier(self) -> float:
        """
        Billing unit applicable for Pav2 billing
        """
        return pulumi.get(self, "multiplier")

    @property
    @pulumi.getter(name="productId")
    def product_id(self) -> str:
        """
        Product Id
        """
        return pulumi.get(self, "product_id")

    @property
    @pulumi.getter(name="skuId")
    def sku_id(self) -> str:
        """
        Sku Id
        """
        return pulumi.get(self, "sku_id")

    @property
    @pulumi.getter(name="termId")
    def term_id(self) -> str:
        """
        Term Id
        """
        return pulumi.get(self, "term_id")


@pulumi.output_type
class SpecificationResponse(dict):
    """
    Specifications of the configurations
    """
    def __init__(__self__, *,
                 name: str,
                 value: str):
        """
        Specifications of the configurations
        :param str name: Name of the specification
        :param str value: Value of the specification
        """
        SpecificationResponse._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            name=name,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             name: Optional[str] = None,
             value: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if name is None:
            raise TypeError("Missing 'name' argument")
        if value is None:
            raise TypeError("Missing 'value' argument")

        _setter("name", name)
        _setter("value", value)

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of the specification
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        Value of the specification
        """
        return pulumi.get(self, "value")


